'==============================================================================
'        Created by: Lkl
'        Version: NX 8
'        Date: 11-05-2013
'       
'
'==============================================================================

'
'
'------------------------------------------------------------------------------
Option Strict Off
Imports System
Imports NXOpen
Imports NXOpen.BlockStyler
Imports NXOpen.UF
Imports System.Collections
Imports Excel = Microsoft.Office.Interop.Excel
Imports System.IO
'------------------------------------------------------------------------------

'------------------------------------------------------------------------------
Public Class LKL_AttributeSetGenerel_Menu
    'class members
    Private Shared theSession As Session
    Private Shared theUI As UI
    Private theDlxFileName As String
    Private theDialog As NXOpen.BlockStyler.BlockDialog
    Private group0 As NXOpen.BlockStyler.UIBlock' Block type: Group
    Private button0 As NXOpen.BlockStyler.UIBlock' Block type: Button
    Private string1 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string2 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string3 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private group As NXOpen.BlockStyler.UIBlock ' Block type: Group
    Private string4 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private enum1 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private separator01 As NXOpen.BlockStyler.UIBlock ' Block type: Separator
    Private string5 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string6 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string7 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private separator0 As NXOpen.BlockStyler.UIBlock ' Block type: Separator
    Private enum2 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private enum3 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private enum4 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private enum5 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private enum6 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private enum7 As NXOpen.BlockStyler.UIBlock ' Block type: Enumeration
    Private group1 As NXOpen.BlockStyler.UIBlock ' Block type: Group
    Private string8 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string9 As NXOpen.BlockStyler.UIBlock ' Block type: String
    Private string10 As NXOpen.BlockStyler.UIBlock ' Block type: String

    Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long ' st excel fokus
    Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long ' st excel fokus
    '-------------------------------------
    Private Shared thePart As Part
    Dim exceltemplate As String = "C:\temp\Attribute_Menu_File.xltx"
    Dim ExcelRetrieveCell As String
    Dim excelfile As String
    Dim folder_name As String
    Dim objExcel = CreateObject("Excel.Application")
    Dim objWorkbook = Nothing
    Dim ws = Nothing
    Dim isAlreadyOpen As Boolean
    Dim isAlreadyClosed As Boolean
    '------------------------------------
    Dim Atr1 As String = "Kunde"
    Dim Atr2 As String = "ProjektBeskrivelse"
    Dim Atr3 As String = "Sagsnr"
    Dim Atr4 As String = "PosNummer"
    Dim Atr5 As String = "TegnNummer"
    Dim Atr6 As String = "ModelBeskrivelse"
    Dim Atr7 As String = "BestillingsNummer"
    Dim Atr8 As String = "Dato"
    Dim Atr9 As String = "PartSti"
    Dim Atr10 As String = "User"
    '-----------------------------------
    Dim matr_attr As String = "Matr" 'attribute navn i part ,som variable i journal
    Dim varmbeh_attr As String = "Varmebehandling" 'attribute navn i part ,som variable i journal
    Dim hrc_attr As String = "Hrc"
    Dim type_attr As String = "Model Type"
    Dim antal_attr As String = "Antal"
    Dim overfl_attr As String = "OverfladeBehandling"
    Dim lev_attr As String = "Levarandr"
    Dim startvalue As Integer ' indeks tller til stning af attributter
    Dim ToList() As String 'indeks tller til at retrieve attributter i menu hvis de allerede findes i NX part


#Region "Block Styler Dialog Designer generator code"
    '------------------------------------------------------------------------------
    'Constructor for NX Styler class
    '------------------------------------------------------------------------------
    Public Sub New()
        Try

            theSession = Session.GetSession()
            thePart = theSession.Parts.Display ' husk denne
            theUI = UI.GetUI()
            theDlxFileName = "C:\temp\LKL_AttributeSetGenerel_Menu.dlx"
            theDialog = theUI.CreateDialog(theDlxFileName)
            theDialog.AddApplyHandler(AddressOf apply_cb)
            theDialog.AddOkHandler(AddressOf ok_cb)
            theDialog.AddUpdateHandler(AddressOf update_cb)
            theDialog.AddInitializeHandler(AddressOf initialize_cb)
            theDialog.AddDialogShownHandler(AddressOf dialogShown_cb)

        Catch ex As Exception

            '---- Enter your exception handling code here -----
            Throw ex
        End Try
    End Sub
#End Region


    Public Shared Sub Main()
        Dim theLKL_AttributeSetGenerel_Menu As LKL_AttributeSetGenerel_Menu = Nothing
        Try

            theLKL_AttributeSetGenerel_Menu = New LKL_AttributeSetGenerel_Menu()
            theLKL_AttributeSetGenerel_Menu.Show()

        Catch ex As Exception

            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        Finally
            If theLKL_AttributeSetGenerel_Menu IsNot Nothing Then
                theLKL_AttributeSetGenerel_Menu.Dispose()
                theLKL_AttributeSetGenerel_Menu = Nothing
            End If
        End Try
    End Sub
    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Shared Function GetUnloadOption(ByVal arg As String) As Integer
        Return CType(Session.LibraryUnloadOption.Immediately, Integer)
    End Function
    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Shared Function UnloadLibrary(ByVal arg As String) As Integer
        Try

            Return 0
        Catch ex As Exception
            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
    End Function

    '------------------------------------------------------------------------------
    'This method shows the dialog on the screen
    '------------------------------------------------------------------------------
    Public Sub Show()
        Try

            theDialog.Show()

        Catch ex As Exception

            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
    End Sub

    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Sub Dispose()
        If theDialog IsNot Nothing Then
            theDialog.Dispose()
            theDialog = Nothing

            If Not isAlreadyClosed = True Then ' exit Excel hvis cancel i dialog menu
                objWorkbook.close()
                objExcel.quit()
                objWorkbook = Nothing
                objExcel = Nothing
                ws = Nothing
                NX("EXCEL CLOSED AND EXIT")
            End If
            '-------------------------------------------------------------------------
        End If
    End Sub

    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Sub initialize_cb()
        Try

            NX("initialize_cb") ' output variable listwindow - just for building VB
            Excel("open") ' open excel file

            group0 = theDialog.TopBlock.FindBlock("group0")
            button0 = theDialog.TopBlock.FindBlock("button0")
            string1 = theDialog.TopBlock.FindBlock("string1")
            string2 = theDialog.TopBlock.FindBlock("string2")
            string3 = theDialog.TopBlock.FindBlock("string3")
            group = theDialog.TopBlock.FindBlock("group")
            string4 = theDialog.TopBlock.FindBlock("string4")
            enum1 = CType(theDialog.TopBlock.FindBlock("enum1"), NXOpen.BlockStyler.UIBlock)
            separator01 = theDialog.TopBlock.FindBlock("separator01")
            string5 = theDialog.TopBlock.FindBlock("string5")
            string6 = theDialog.TopBlock.FindBlock("string6")
            string7 = theDialog.TopBlock.FindBlock("string7")
            separator0 = theDialog.TopBlock.FindBlock("separator0")
            enum2 = CType(theDialog.TopBlock.FindBlock("enum2"), NXOpen.BlockStyler.UIBlock)
            enum3 = CType(theDialog.TopBlock.FindBlock("enum3"), NXOpen.BlockStyler.UIBlock)
            enum4 = CType(theDialog.TopBlock.FindBlock("enum4"), NXOpen.BlockStyler.UIBlock)
            enum5 = CType(theDialog.TopBlock.FindBlock("enum5"), NXOpen.BlockStyler.UIBlock)
            enum6 = CType(theDialog.TopBlock.FindBlock("enum6"), NXOpen.BlockStyler.UIBlock)
            enum7 = CType(theDialog.TopBlock.FindBlock("enum7"), NXOpen.BlockStyler.UIBlock)
            group1 = theDialog.TopBlock.FindBlock("group1")
            string8 = theDialog.TopBlock.FindBlock("string8")
            string9 = theDialog.TopBlock.FindBlock("string9")
            string10 = theDialog.TopBlock.FindBlock("string10")

        Catch ex As Exception

            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
    End Sub

    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Sub dialogShown_cb()
        Try

            ReadExcel("A1")
            find_attr_in_excelfile(Atr1, string1) 'krer function Find_attr
            ReadExcel("A2")
            find_attr_in_excelfile(Atr2, string2) 'krer function Find_attr
            ReadExcel("A3")
            find_attr_in_excelfile(Atr3, string3) 'krer function Find_attr
            '-------------------------------------------------------------------------

            Dim type_List As arraylist = New arraylist()
            type_List.Add("-")
            type_List.Add("FremstillingsDel")
            type_List.Add("StandardDel")
            type_List.Add("NormDel")
            '-------------------------------------------------------------------------

            Dim antal_List As arraylist = New arraylist()
            antal_List.Add("-")
            Dim taller1 As Integer = 1
            Dim stringIndeks As String
            For taller1 = 1 To 200  '
                stringIndeks = taller1
                antal_List.Add(stringIndeks)
                taller1 += 0
            Next
            '-------------------------------------------------------------------------
            Dim matr_List As arraylist = New arraylist()
            matr_List.Add("-")
            matr_List.Add("Stavax")
            matr_List.Add("Ramax")
            matr_List.Add("Alu")
            matr_List.Add("Asp")
            matr_List.Add("Orvar")
            '-------------------------------------	

            Dim varmbeh_List As arraylist = New arraylist()
            varmbeh_List.Add("-")
            varmbeh_List.Add("Hrdes")
            varmbeh_List.Add("Nitreres")
            varmbeh_List.Add("Eloxeres")
            varmbeh_List.Add("Anodiseres")
            varmbeh_List.Add("Sejhrdes")
            varmbeh_List.Add("HrdAnodiseres")
            '--------------------------------------

            Dim hrc_List As arraylist = New arraylist()
            hrc_List.Add("-")
            hrc_List.Add("40")
            hrc_List.Add("42")
            hrc_List.Add("44")
            hrc_List.Add("46")
            hrc_List.Add("48")
            hrc_List.Add("50")
            hrc_List.Add("52")
            hrc_List.Add("54")
            hrc_List.Add("56")
            hrc_List.Add("58")
            hrc_List.Add("60")
            '--------------------------------------
            Dim overfl_List As arraylist = New arraylist()
            overfl_List.Add("-")
            overfl_List.Add("Eloxeres")
            overfl_List.Add("Belgges")

            '--------------------------------------
            Dim lev_List As arraylist = New arraylist()
            lev_List.Add("-")
            lev_List.Add("Hasco")
            lev_List.Add("Uddeholm")
            lev_List.Add("Ibsen")
            lev_List.Add("Meuseburg")
            lev_List.Add("Normteknik")

            '----------------------------------------------
            ' 1.Parameter=AttributeVariable, 2.Parameter=ArrayListVariable, 3.Parameter=Enum(menu)Variable
            runSetEnumFunc(matr_attr, matr_List, enum3)
            runSetEnumFunc(varmbeh_attr, varmbeh_List, enum4)
            runSetEnumFunc(hrc_attr, hrc_List, enum5)
            runSetEnumFunc(type_attr, type_List, enum1)
            runSetEnumFunc(antal_attr, antal_List, enum2)
            runSetEnumFunc(overfl_attr, overfl_List, enum6)
            runSetEnumFunc(lev_attr, lev_List, enum7)
            '-----------------------------------------------
            find_attr(Atr4, string4) 'krer function Find_attr
            find_attr(Atr5, string5) 'krer function Find_attr
            find_attr(Atr6, string6) 'krer function Find_attr
            find_attr(Atr7, string7) 'krer function Find_attr
            find_attr(Atr8, string8) 'krer function Find_attr
            find_attr(Atr9, string9) 'krer function Find_attr
            find_attr(Atr10, string10) 'krer function Find_attr

        Catch ex As Exception

            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
    End Sub

    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Function apply_cb() As Integer
        Dim errorCode As Integer = 0
        Try

            set_attr(Atr1, string1) 'krer function SET_attr
            set_attr(Atr2, string2) 'krer function SET_attr
            set_attr(Atr3, string3) 'krer function SET_attr
            set_attr(Atr4, string4) 'krer function SET_attr
            set_attr(Atr5, string5) 'krer function SET_attr
            set_attr(Atr6, string6) 'krer function SET_attr
            set_attr(Atr7, string7) 'krer function SET_attr
            '-------------------------------------------------------------------------
            set_attr(matr_attr, enum3)
            set_attr(varmbeh_attr, enum4)
            set_attr(hrc_attr, enum5)
            set_attr(type_attr, enum1)
            set_attr(antal_attr, enum2)
            set_attr(overfl_attr, enum6)
            set_attr(lev_attr, enum7)
            '------------------------------------------------------------------------
            set_date_attr(Atr8) 'krer function Find_attr
            set_path_attr(Atr9) 'krer function Find_attr
            set_user_attr(Atr10) 'krer function Find_attr

        Catch ex As Exception

            errorCode = 1
            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
        apply_cb = errorCode
    End Function

    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Function update_cb(ByVal block As NXOpen.BlockStyler.UIBlock) As Integer
        Try

            If block Is button0 Then

                List_EXCEL_file()

            ElseIf block Is string1 Then

                set_Attr(Atr1, string1)
                WRITE_EXCEL("A1", string1.GetProperties.GetString("Value"))

            ElseIf block Is string2 Then

                set_Attr(Atr2, string2)
                WRITE_EXCEL("A2", string2.GetProperties.GetString("Value"))

            ElseIf block Is string3 Then

                set_Attr(Atr3, string3)
                WRITE_EXCEL("A3", string3.GetProperties.GetString("Value"))
                '-------------------------------------------------------------------------

            ElseIf block Is string4 Then
                set_Attr(Atr4, string4)

            ElseIf block Is string5 Then
                set_Attr(Atr5, string5)

            ElseIf block Is string6 Then
                set_Attr(Atr6, string6)

            ElseIf block Is string7 Then
                set_Attr(Atr7, string7)

            End If

        Catch ex As Exception

            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
        update_cb = 0
    End Function
    
    '------------------------------------------------------------------------------

    '------------------------------------------------------------------------------
    Public Function ok_cb() As Integer
        Dim errorCode as Integer = 0
        Try

            Excel("close") ' save and close excel file

            errorCode = apply_cb()

        Catch ex As Exception

            errorCode = 1
            theUI.NXMessageBox.Show("Block Styler", NXMessageBox.DialogType.Error, ex.ToString)
        End Try
        ok_cb = errorCode
    End Function
    '=========================== NX LISTING WINDOW FUNCTION=======================================

    Public Function NX(ByVal input As String) '' output variable listwindow - just for building VB

        Dim displayPart As Part = theSession.Parts.Display
        Dim lw As ListingWindow = theSession.ListingWindow()
        lw.open()
        lw.writeline(input)
    End Function

    '=========================== CREATE EXCEL FILE "DATA" =====================================

    Public Function EXCEL(ByVal OpenClose As String) ' function open,create,save and close excel


        Dim ufs As UFSession = UFSession.GetUFSession()
        Dim dispPart_name As String
        Dim dispPart As Part = theSession.Parts.Display
        ufs.Part.AskPartName(dispPart.Tag, dispPart_name)

        folder_name = Left(dispPart_name, Instrrev(dispPart_name, "\") - 1) ' finder work dir

        Dim sb As New System.Text.StringBuilder()
        Dim Fullpath As String = sb.Append(folder_name).Append("\").Append("AttrData").Append(".Xlsx").ToString() ' generate fullpath Excel file
        excelfile = Fullpath

        If OpenClose = "close" Then 'goto close excel section
            GoTo close
        End If

        If isAlreadyOpen = True Then 'goto end if excel already is open
            nx(isAlreadyOpen)
            GoTo afterClose
        End If

        If Not IO.File.Exists(excelFile) Then 'create Excel section from template and save to dir

            objWorkbook = objExcel.Workbooks.Add(excelTemplate)
            objWorkbook.SaveAs(excelFile)
            ws = objWorkbook.Worksheets("Ark1")
            objExcel.visible = False
            nx("EXCEL CREATED AND OPEN")
            isAlreadyOpen = True
        Else
            objWorkbook = objExcel.Workbooks.Open(excelfile) ' open Excel section in dir
            ws = objWorkbook.Worksheets("Ark1")
            objExcel.visible = False
            nx("EXCEL OPEN")
            isAlreadyOpen = True
        End If

        GoTo afterClose

close:  ' close excel section

        objExcel.DisplayAlerts = False
        objWorkbook.SaveAs(excelFile)
        objWorkbook.close()
        objExcel.quit()
        objWorkbook = Nothing
        objExcel = Nothing
        ws = Nothing
        NX("EXCEL SAVED AND CLOSED") ' output variable listwindow - just for building VB
        isAlreadyClosed = True ' flag til dispose function - se Sub Dispose

afterClose:

    End Function

    '============================ SET PART ATTRIBUTE var= NUM (string eller enum )===========================

    Public Function set_Attr(ByVal SetAttr As String, ByRef num As NXOpen.BlockStyler.UIBlock)

        Try
            thePart.SetAttribute(SetAttr, num.GetProperties.GetString("Value")) 'fra string menu
            ' IF nx("string")
        Catch ex As Exception
            thePart.SetAttribute(SetAttr, num.GetProperties.GetEnumAsString("Value")) 'fra enum menu
            'IF nx("enum")
        End Try

    End Function

    '===== FINDER EKSISTERENDE (hvis den findes) ATTRIBUTE OG STTER I MENU , ELLERS LSES FRA EXCEL DATA=====

    Public Function find_attr_in_excelfile(ByVal CatchAttr As String, ByRef num As NXOpen.BlockStyler.UIBlock)

        num.GetProperties.SetString("Value", ExcelRetrieveCell)

    End Function
    '===================== LSER FRA EXCEL =========================================================

    Public Function ReadExcel(ByVal Cell_Range As String)

        NX(ws.Range(Cell_Range).Value)
        ExcelRetrieveCell = (ws.Range(Cell_Range).Value)

    End Function

    '======================SKRIVER TIL EXCEL========================================================

    Public Function WRITE_EXCEL(ByVal Cell_Range As String, ByVal Cell_Str As String)

        ws.Range(Cell_Range).value = (Cell_Str)
        objWorkbook.Save()
        NX(Cell_Str & "INPUT") ' output variable listwindow - just for building VB

    End Function


    '========================SHOW EXCEL=============================================================
    Public Function List_EXCEL_file() ' lister excel file i excel

        Try

            objExcel.visible = True

            Excel_Focus() ' Excel_Focus

        Catch ex As Exception
            Msgbox("filepath til excel ikke fundet")
        End Try
        Exit Function

    End Function
    '========================FOCUS EXCEL============================================================

    Public Sub Excel_Focus()
        Dim exlHandle As Long
        Dim exlTitle As String
        exlTitle = objExcel.Caption
        exlHandle = FindWindow(vbNullString, exlTitle)
        SetForegroundWindow(exlHandle)
    End Sub

    '===========================ENUM MENU CALCULATOR============================

    Public Function runSetEnumFunc(ByVal input_attr As String, ByVal inputArray As Arraylist, ByVal EnumVariant As NXOpen.BlockStyler.UIBlock) 'sger efter allerede sat attribute fra part ,og stter i menu,samt klargre menu til skrivning af ny valgt attribute value
        Dim ufs As UFSession = UFSession.GetUFSession()
        Dim thePartAttr As NXOpen.Tag = NXOpen.Tag.Null
        ufs.Attr.AskPartAttribute(thePartAttr)

        If thePartAttr <> Tag.Null Then ' sger efter eksisterende partattribute , hvis den findes, sges vrdiens indeks nr ,til brug ved Enum menu
            Dim type As Int32 = UFConstants.UF_ATTR_any
            Dim title As String = input_attr
            Dim realtype As Int32
            Dim thepart As Part = thesession.Parts.Work
            Dim retr_existing As String
            Dim taller As Integer = 0   'array body tller
            Dim indeks As Integer = 0       'array indeks tller

            ufs.Attr.FindAttribute(thePartAttr, type, title, realtype)
            If realtype <> 0 Then
                retr_existing = thesession.Parts.Work.GetStringAttribute(input_attr)

                For taller = 0 To inputArray.count - 1  'loop sger efter attribute vrdi , output "startvalue" = indeksplads i arraylist 
                    If retr_existing = (inputArray.item(indeks)) Then
                        startvalue = indeks
                    End If
                    indeks += 1
                Next

            Else : startvalue = 0
            End If
        End If

        ToList = CType(inputArray.ToArray(GetType(String)), String()) ' indlser arraylist til ny string array ,indeks sttes automatisk til brug i Enum Visning(menu)

        EnumVariant.GetProperties().SetEnumMembers("Value", ToList) ' indeks fra Tolist til at beregne attribute nr i arraylist og skriver fra ENUM_menu
        EnumVariant.GetProperties().SetEnum("Value", startvalue) 'finder eksisterende attr vrdi og stter i ENUM_menu

        Return Tolist

    End Function

    '==============finder allerede sat attribute og stter i menu===================================

    Public Function find_attr(ByVal CatchAttr As String, ByRef num As NXOpen.BlockStyler.UIBlock)

        Dim ufs As UFSession = UFSession.GetUFSession()
        Dim thePartAttr As NXOpen.Tag = NXOpen.Tag.Null
        ufs.Attr.AskPartAttribute(thePartAttr)

        If thePartAttr <> Tag.Null Then
            Dim type As Int32 = UFConstants.UF_ATTR_any
            Dim title As String = CatchAttr
            Dim realtype As Int32
            Dim thepart As Part = thesession.Parts.Work

            ufs.Attr.FindAttribute(thePartAttr, type, title, realtype)
            If realtype <> 0 Then
                num.GetProperties.SetString("Value", thePart.GetStringAttribute(CatchAttr))
            End If
        End If

    End Function

    '==================set Dato Attribute===========================================================

    Public Function set_date_Attr(ByVal SetAttr As String)

        Dim TimeNote As DateTime
        TimeNote = System.DateTime.Now()
        Dim TimeNoteString As String() = TimeNote.GetDateTimeFormats()

        thePart.SetAttribute(SetAttr, TimeNoteString(4))

    End Function

    '================ set filepath Attribute========================================================

    Public Function set_path_Attr(ByVal SetAttr As String)

        Dim strPath As String = thePart.fullpath  'get the full file path

        thePart.SetAttribute(SetAttr, strPath)

    End Function
    '===================set User Atribute===========================================================
    Public Function set_user_Attr(ByVal SetAttr As String)

        Dim user As String = Environment.UserName

        thePart.SetAttribute(SetAttr, user)

    End Function

    '===============================================================================================
End Class
